#!/usr/local/bin/perl
use Socket;

$home = "/home/ugrad12/is/95/white/";
$useraddress = "white\@jks.is.tsukuba.ac.jp";
$agentname = "DiaryCheck.pl/0.6b";

$sock_addr = 'S n a4 x8';
$hostname = '$ENV{HOST}';
($name,$aliases,$proto) = getprotobyname('tcp');
$portnum = 80;

($name,$aliases,$type,$len,$thisaddr) = gethostbyname($hostname);
$client_addr = pack($sock_addr,&AF_INET,0,$thisaddr);
$STDFORMAT = "5 4 3 6 7";
$HINAFORMAT = "3 4 5 6 7";

open(LOG,"$home/.DiaryCheckLog");
while(<LOG>){
    chop;
    ($url,$time) = split('%%');
    $timedb{$url} = $time;
}
close(LOG);

open(RESULT,">$home/.DiaryCheckResult.html");
open(LOG,">$home/.DiaryCheckLog");
open(COM,"$home/.DiaryCheckrc");
while(<COM>){
    undef(%value);
    $value{last} = 0;
    s/^(.*?) //;
    $command = $1;
    while(s/^(.*?)="(.*?[^\\])"\s*//){
	$value{$1} = $2;
    }
    $_ = $command;
    if(/ANTENNA/)   {&ANTENNA();}
    elsif(/GET/)    {&GET();}
    elsif(/HEAD/)   {&HEAD();}
}

sub ANTENNA{
    undef(@url,@time);
    $url = $value{url};
    $url =~ /http:\/\/(.*?)(\/.*\/)(.*)/;
    $servname = $1;
    $path = "$2$3";
    $format = $value{$format};
    if($format eq ""){$format = $HINAFORMAT;}
    $method = "GET";
    $mode = "ANTENNA";

    $count = 0;
    while(<COM>){
	if(/^ENDANTENNA/){
	    last;
	}else{
	    undef(%value);
	    while(s/^\s*(.*?)="(.*?[^\\])"\s*//){
		$value{$1} = $2;
	    }
	    $url[$count]   = $value{url};
	    $title[$count] = $value{title};
	    if($title[$count] eq ""){$title[$count] = $url[$count];}
	    $count++;
	}
    }
    if(($state = &MakeConnect($servname)) ne "0"){
	print "(ANTENNA:$url):$state\n";
	for($i=0;$i<$count;$i++){
	    print RESULT "$state($timedb{$url[$i]}) ; <a href='$url[$i]' target='diarycheck'>$title[$i]</a><br>\n";
	    print LOG "$url[$i]%%$timedb{$url[$i]}\n";
	}
	return;
    }
    &SendRequest11($method,$servname,$path);
    while(<S>){
	for($i=0;$i<$count;$i++){
	    if(/$url[$i]/){
		$time[$i] = $_;
	    }
	}
    }
    close(S);
    for($i=0;$i<$count;$i++){printcheckresult($url[$i],,$title[$i],$time[$i]);}
    return;
}

sub GET{
    $url = $value{url};
    $url =~ /http:\/\/(.*?)(\/.*\/)(.*)/;
    $title = $value{title};
    if($title eq ""){$title = $url;}
    $servname = $1;
    $path = "$2$3";
    $keyword = $value{key};
    if($keyword eq ""){$keyword = "Last-Modified:";}
    $format = $value{format};
    if($format eq ""){$format = $STDFORMAT;}
    $method = "GET";
    &GetData();
}

sub HEAD{
    $url = $value{url};
    $url =~ /http:\/\/(.*?)(\/.*\/)(.*)/;
    $title = $value{title};
    if($title eq ""){$title = $url;}
    $servname = $1;
    $path = "$2$3";
    $keyword = "Last-Modified:";
    $format = $value{format};
    if($format eq ""){$format = $STDFORMAT;}
    $method = "HEAD";
    &GetData();
}

sub MakeConnect{
    local($servname) = @_;
    ($name,$aliases,$portnum)
	= getservbyname($portnum,'tcp') unless $portnum =~/^\d+$/;;
    ($name,$aliases,$type,$len,$thataddr) = gethostbyname($servname);
    $serv_addr = pack($sock_addr,&AF_INET,80,$thataddr);
    
    socket(S,&PF_INET,&SOCK_STREAM,$proto)||return "cannot get a socket";
    bind(S,$client_addr) ||return "cannot bind socket";
    connect(S,$serv_addr) ||return "cannot connect socket";
    select(S);
    $| = 1;
    select(STDOUT);
    return 0;
}

sub SendRequest10{
    local($method,$path) = @_;
    print S "$method $path HTTP/1.0\r\n";
    print S "User-Agent: $agentname\r\n";
    print S "From: $useraddress\r\n";
    print S "\r\n";
}

sub SendRequest11{
    local($method,$servname,$path) = @_;
    print S "$method $path HTTP/1.1\r\n";
    print S "User-Agent: $agentname\r\n";
#   print S "If-Modified-Since: Sat, 29 Oct 1994 19:43:31 GMT\r\n";
#   print S "Referer: (URI)\r\n";
    print S "From: $useraddress\r\n";
    print S "Host: $servname\r\n";
    print S "\r\n";
}

sub GetData{
    if(($state = &MakeConnect($servname)) ne "0"){
	print "$url:$state\n";
	print RESULT "$state($timedb{$url}) ; <a href='${url}' target='diarycheck'>$url</a><br>\n";
	print LOG "$url%%$timedb{$url}\n";
	return;
    }
    &SendRequest10($method,$path);
#   &SendRequest11($method,$servname,$path);
    print "${url}\n" if ($value{verbose} == 1);
    while(<S>){
	if(/($keyword\s*.*)/i){
	    $time = $1;
	    print "$time\n" if ($value{verbose} == 1);
	    if($value{last} == 0){
		while(<S>){
		}
	    }
	}
    }
    &printcheckresult($url,$title,$time);
    close(S);
}

sub printcheckresult{
    local($url,$title,$_) = @_;
    local($time);
    s/Jan/01/;
    s/Feb/02/;
    s/Mar/03/;
    s/Apr/04/;
    s/May/05/;
    s/Jun/06/;
    s/Jul/07/;
    s/Aug/08/;
    s/Sep/09/;
    s/Oct/10/;
    s/Nov/11/;
    s/Dec/12/;

    undef(@timeval);
    @timeval = split(/[ ,\-:\/\.<>\(\)]+/);
    $NA = push(@timeval,('--'))-1;
    $format =~ s/\%/$NA/g;
    @formatval = split(/ /,$format);
    $year = $timeval[$formatval[0]];
    $month = $timeval[$formatval[1]];
    $day = $timeval[$formatval[2]];
    $hour = $timeval[$formatval[3]];
    $minute = $timeval[$formatval[4]];
    if(/GMT/){
	$hour += 9;
	if($hour > 24){
	    $day +=1;
	    $hour -= 24;
	}
    }
    $time = "$year/$month/$day $hour:$minute";

    if($time ne $timedb{$url}){print RESULT "+ ";}
    print RESULT "$time ; <a href='${url}' target='diarylook'>$title</a><br>\n";
    print LOG "$url%%$time\n";
}
